function sol_obj = eval(model_obj, var_obj)

% ROME_MODEL\EVAL Evaluates the current full variable with deflected
% components. Returns a rome_sol object
%
% Modified by:
% Joel

if(isa(var_obj, 'rome_var'))
    sol_obj = rome_sol;
    sol_obj.LDRAffineMap = squeeze(model_obj.eval_var(var_obj(:)));
    [sol_obj.DeflectCoeff, sol_obj.DeflectAffineMap] = model_obj.eval_deflect(var_obj);
    sol_obj.Size = var_obj.Size;
    
    % catch abberant case
    if(all(var_obj.TotalSize == 1))
        sol_obj.LDRAffineMap = sol_obj.LDRAffineMap';
    end
else
    error('rome_model:eval_all:OnlyRomeVar', 'Only accepts rome_var objects.');
end

% ROME: Copyright (C) 2009 by Joel Goh and Melvyn Sim
% See the file COPYING.txt for full copyright information.
